#!/usr/bin/python

import os
import sys
import glob

username            = os.getlogin()
sourceDir           = os.getcwd()


# fill the following out
#------------------------------------------------------------------------------------------------
myHome              = os.path.join("/", os.path.join("nfs", os.path.join("home", "sushil")))
assignmentName      = "as5"
destinationPathRoot = os.path.join("/", os.path.join ("nfs", os.path.join("home", os.path.join("sushil", os.path.join("cs381", "assignments")))))
destinationDir      = os.path.join(destinationPathRoot, os.path.join(assignmentName, username))
inputFiles          = glob.glob(os.path.join(destinationPathRoot, os.path.join(assignmentName, "*.in")))
correctOutputs      = os.path.join(destinationPathRoot, os.path.join(assignmentName, "outputs"))
gradingHome         = os.path.join(myHome, os.path.join("classes", os.path.join("135", os.path.join("grading", "project5"))))
#------------------------------------------------------------------------------------------------
#print sourceDir, destinationDir
#print "Input files: ", inputFiles
#---------------------------------------------------
def printErrorMsg():
    print "********* Unsuccessful submission. ************\n"
    print "Constraints:"
    print "-1. Read the project submission instructions in my project description"
    print "0. Your project folder should be /nfs/home/<netid>/as<n>"
    print "1. Make sure your current directory is NOT on a USB stick, or other external media"
    print "2. Make sure that your current directory contains all your submission files"
    print "3. Contact a TA or Fellow for help"
    print "              *********************\n"

def CleanDestination():
    try:
        import shutil
        if os.path.exists(destinationDir): # if destination dir exists remove it
            shutil.rmtree(destinationDir)
        if not os.path.exists(destinationDir): # if destination dir does not exist, make it
            os.makedirs(destinationDir, 0700)
            # the two ifs above remove the old copy of a submission and make a new folder for submission

    except OSError:
        print "-----------Clean destination Error!--------------------------"
        printErrorMsg()
        raise OSError
#---------------------------------------------------

def CopyFiles(src, pattern, shouldPrintProgress):
#-----------source and destination known-------
# now copy
#-----------------------------------------------
    import shutil
    sourceFiles = []

    try:
        allFiles = []
        srcPattern = os.path.join(src, pattern)
        sourceFiles = glob.glob(srcPattern)
    #    print "Source files: ", sourceFiles

        if (len(sourceFiles) == 0):
            print "You are in the folder: ", src
            print "I cannot find files like, ", pattern, " here"
            #print "assuming you don't need these files for your code...."
            raise OSError

        for f in sourceFiles:
            if shouldPrintProgress:
                print 'Copying--------------->: ', f
            if os.path.isdir(f):
                shutil.copytree(f, os.path.join(destinationDir, os.path.basename(f)));
            else:
                shutil.copy2(f, destinationDir)
        
    except OSError:
        print "------------------------File copy error-------------------------------"
        raise OSError


if __name__ == "__main__":
    try:
        CleanDestination()
        CopyFiles(sourceDir, "*.py", True)
        CopyFiles(sourceDir, "*.cfg", True)
        CopyFiles(sourceDir, "*.log", True)

        print "\n************** Successfully submitted 381 as5 ******************\n"        
    except OSError:
        printErrorMsg()
        raise

