#!/usr/bin/python

import os
import sys
import glob

username            = os.getlogin()
sourceDir           = os.getcwd()


# fill the following out
#------------------------------------------------------------------------------------------------
myHome              = os.path.join("/", os.path.join("nfs", os.path.join("home", "sushil")))
assignmentName      = "project4"
destinationPathRoot = os.path.join("/", os.path.join ("nfs", os.path.join("home", os.path.join("sushil", os.path.join("cs1", "assignments")))))
destinationDir      = os.path.join(destinationPathRoot, os.path.join(assignmentName, username))
inputFiles          = glob.glob(os.path.join(destinationPathRoot, os.path.join(assignmentName, "*.in")))
correctOutputs      = os.path.join(destinationPathRoot, os.path.join(assignmentName, "outputs"))
gradingHome         = os.path.join(myHome, os.path.join("classes", 
                                                        os.path.join("135", os.path.join("grading", "project4"))))
#------------------------------------------------------------------------------------------------
#print sourceDir, destinationDir
#print "Input files: ", inputFiles

def printErrorMsg():
    print "********* UNSUCCESSFUL SUBMISSION, Contact a TA or Fellow for help ************\n"

def CleanDestination():

    try:
        import shutil
        if os.path.exists(destinationDir): # if destination dir exists remove it
            shutil.rmtree(destinationDir)
        if not os.path.exists(destinationDir): # if destination dir does not exist, make it
            os.makedirs(destinationDir, 0700)
            # the two ifs above remove the old copy of a submission and make a new folder for submission

    except OSError:
        print "------------------------File copy error-------------------------------"
        raise OSError



def CopyFiles(src, pattern, shouldPrintProgress):
#-----------source and destination known-------
# now copy
#-----------------------------------------------

    import shutil
    sourceFiles = []

#print 'uid, euid = ', os.getuid(), os.geteuid()
    try:

        allFiles = []
        srcPattern = os.path.join(src, pattern)
        sourceFiles = glob.glob(srcPattern)
    #    print "Source files: ", sourceFiles

        if (len(sourceFiles) == 0):
            print "You are in the folder: ", src
            print "I cannot find files like, ", pattern, " here"
            print "assuming you don't need these files for your code...."
            #raise OSError

        for f in sourceFiles:
            if shouldPrintProgress:
                print 'Copying--------------->: ', f
            shutil.copy2(f, destinationDir)
        
    except OSError:
        print "------------------------File copy error-------------------------------"
        raise OSError




#---------------------------------------------------
# start compilation
#---------------------------------------------------
def sushilid(sushilsuid):
    def result():
        print os.getuid(), os.getgid()
        os.setuid(sushilsuid)
        print os.getuid(), os.getgid()
    return result

def getCommandLine(name):
    if (os.path.exists("censusData.cpp") and os.path.exists("censusData.h")):
        return "g++ -o " + name + " censusData.cpp " + name+".cpp"
    else:
        return "g++ -o " + name + " " + name+".cpp"

def Build():

    print "--------------------Starting compilation-------------------------"

    import subprocess
    import shlex

    try:
        os.chdir(destinationDir);
        os.chmod(destinationDir, 0777)

        commandLine = getCommandLine("bs")
        args = shlex.split(commandLine)
        print "Compiling bs with: "
        print  commandLine
        print ""
        returnValue = subprocess.call(args)

        commandLine = getCommandLine("lsearch")
        args = shlex.split(commandLine)
        print "Compiling lsearch with: "
        print  commandLine
        print ""
        returnValue = subprocess.call(args)

        commandLine = getCommandLine("minmax")
        args = shlex.split(commandLine)
        print "Compiling minmax with: "
        print  commandLine
        print ""
        returnValue = subprocess.call(args)


        os.chmod(destinationDir, 0700)

    except OSError:
        print "-------------------------Compiling Error----------------------------"
        raise OSError


def CheckBuild(name):

    #-------------------------------------------------
    # check if run exists
    #-------------------------------------------------
    try:
        if not os.path.exists(os.path.join(destinationDir, name)):
            print "----------------Compiler errors with " + name + ", exiting...----------------------"
            return False
        else:
            return True
    except OSError:
        print "---------------Could not check for executable---------------------"
        raise OSError
    #else
    print "-------------------Compiling Successful: " + name 
    print "-----------------------Ready to Run: " + name


def Run(name):
    #------------------------------------------
    #--now execute with inputfiles
    #-----------------------------------------

    outfilename = os.path.join(destinationDir, "out")
    #print "Output: ", outfilename
    try:

        if os.path.exists(outfilename):
            os.unlink (outfilename)

        outfd = open(outfilename, "a")
        #print "Input files: ", inputFiles
        if inputFiles:
            for f in inputFiles:
                commandline = "./"+name + " < " + f + " >> " + outfilename
                infd = open(f, "r")

                head, tail = os.path.split(f)
                outfd.write("**Test input file: "+ tail + "\n");
                outfd.flush()

                args = shlex.split(commandline)
                returnValue = subprocess.call(args, stderr=subprocess.STDOUT, stdout=outfd, stdin=infd)
                outfd.flush()
                outfd.write("**End of test input\n")
                outfd.flush()
                infd.close()
        else:
            os.chmod(destinationDir, 0777)
            commandline = "./crack"
            args = shlex.split(commandline)
            print "Running: " , args
            returnValue = subprocess.Popen(args, stderr=subprocess.STDOUT, stdout = outfd)
            # import time
            # time.sleep(5)
            # returnValue.terminate()
            print "Finished running: ", commandline
#            commandline = "/usr/bin/reset"
#            args = shlex.split(commandline)
#            returnValue = subprocess.call(args)#, stderr=subprocess.STDOUT)
    #     returnValue = subprocess.Popen(args)
            os.chmod(destinationDir, 0700)

        outfd.close()

    except OSError:
        print "-------------------------Execution Error----------------------------"
        raise OSError



def RunMinMax():
    #------------------------------------------
    #--execute linear search and test with inputfiles
    #-----------------------------------------

    outfilename = os.path.join(destinationDir, "outMinMax")
    #   print "Output: ", outfilename
    try:

        if os.path.exists(outfilename):
            os.unlink (outfilename)

        import subprocess
        import shlex
        os.chmod(destinationDir, 0777)

        outfd = open(outfilename, "w")

        for category in range(0, 6):
            
            infileName = os.path.join(destinationDir, "censusData1")
            infd = open(infileName, "r")
            commandline = "./minmax 25000 " + str(category)
            args = shlex.split(commandline)
            print "Running: " , commandline 
            returnValue = subprocess.Popen(args, stderr=subprocess.STDOUT, stdout=outfd, stdin=infd)
            returnValue.wait()
            print "Finished running: ", commandline
            infd.close()


        outfd.flush()
        outfd.close()
#        print "Closed ", outfilename

    except OSError:
        print "-------------------------Execution Error----------------------------"
        raise OSError

#--------------------------------------------------------------------------------------

def RunLSearch():
    #------------------------------------------
    #--execute linear search and test with inputfiles
    #-----------------------------------------

    outfilename = os.path.join(destinationDir, "outLSearch")
#    print "Output: ", outfilename
    try:

        if os.path.exists(outfilename):
            os.unlink (outfilename)

        import subprocess
        import shlex
        os.chmod(destinationDir, 0777)

        outfd = open(outfilename, "w")
        infileName = os.path.join(destinationDir, "censusData1")
        infd = open(infileName, "r")
        commandline = "./lsearch 25000 LUIS"
        args = shlex.split(commandline)
        print "Running: " , commandline, " will take a few seconds. Patience..."
        returnValue = subprocess.Popen(args, stderr=subprocess.STDOUT, stdout=outfd, stdin=infd)
        returnValue.wait()
        print "Finished running: ", commandline

        infd.close()
        outfd.flush()
        outfd.close()
        #print "Closed ", outfilename
    except OSError:
        print "-------------------------Execution Error----------------------------"
        raise OSError

#--------------------------------------------------------------------------------------

def RunBS():
    #------------------------------------------
    #--execute bubblesort and test with inputfiles
    #-----------------------------------------

    outfilename = os.path.join(destinationDir, "outBS")
#    print "Output: ", outfilename
    try:

        if os.path.exists(outfilename):
            os.unlink (outfilename)

        import subprocess
        import shlex
        os.chmod(destinationDir, 0777)

        outfd = open(outfilename, "w")
        infileName = os.path.join(destinationDir, "censusData1")
        infd = open(infileName, "r")
        commandline = "./bs 25000"
        args = shlex.split(commandline)
        print "Running: " , commandline, " will take a few seconds. Patience..."
        returnValue = subprocess.Popen(args, stderr=subprocess.STDOUT, stdout=outfd, stdin=infd)
        returnValue.wait()
        print "Finished running: ", commandline

        infd.close()
        outfd.flush()
        outfd.close()
        #print "Closed ", outfilename
        

    except OSError:
        print "-------------------------Execution Error----------------------------"
        raise OSError



def CheckExists(name, count, categories, lines, gfd):
    for line in lines:
        if name in line:
            if str(count) in line:
                catCount = 0
                for category in categories:
                    if str(category) in line:
                        catCount += 1
                if catCount >= 5:
                    return 10;
    return 0

def FeedbackBS():
    #---------------------------------------------
    #--What's your output
    #---------------------------------------------

    #----------printFile(outfilename)------------

    outfilename = os.path.join(destinationDir, "outBS")

    try:
        if os.path.exists(outfilename):
            outfd = open(outfilename)
            lines = outfd.readlines()
            outfd.close()
#            print "Number of Lines: ", len(lines)
            mostCommonName = "BROWN"
            cCount         = 1380145
            cCategories    = (60.71, 34.54, 0.41, 0.83, 1.86, 1.64)
            medianName     = "WIEDENHEFT"
            mCount         = 133
            mCategories    = (96.99, -1.00, 0.00, 0.00, -1.00, -1.00)
            lastName       = "ZUSI"
            lCount         = 100
            lCategories    = (99.00, 0.00, 0.00, 0.00, 0.00, 0.00)
            gfd = open('grading.data', 'w')
            score = 0;
            score = score + CheckExists(mostCommonName, cCount, cCategories, lines, gfd)
            score = score + CheckExists(medianName, mCount, mCategories, lines, gfd)
            score = score + CheckExists(lastName, lCount, lCategories, lines, gfd)
            print "\n\tsorting score: ",  (score/30.0 * 100.0), "%\n"
            gfd.write("\n\tsorting score: " + str((score/30.0 * 100.0)) + "%\n")
            gfd.close()

    except OSError:
        print "-------Could not print program output--------"
        raise OSError

def FeedbackLSearch():
    #----------printFile(outfilename)------------

    outfilename = os.path.join(destinationDir, "outLSearch")

    try:
        if os.path.exists(outfilename):
            outfd = open(outfilename)
            lines = outfd.readlines()
            outfd.close()
            name           = "LUIS"
            count          = 6845
            categories     = (25.58, 4.49, 6.05, 0.41, 2.91, 60.57)
            gfd = open('grading.data', 'a')
            score = 0;
            score = score + CheckExists(name, count, categories, lines, gfd)
            print "\n\tSearch score: ",  (score/10.0) * 100.0, "%\n"
            gfd.write("\n\tSearch score: " + str((score/10.0) * 100.0) +  "%\n")
            gfd.close()

    except OSError:
        print "-------Could not print program output--------"
        raise OSError

def FeedbackMinMax():
    #---------------------------------------------
    #--What's your output
    #---------------------------------------------

    #----------printFile(outfilename)------------

    outfilename = os.path.join(destinationDir, "outMinMax")

    try:
        if os.path.exists(outfilename):
            outfd = open(outfilename)
            lines = outfd.readlines()
            outfd.close()

            name           = "RAMIREZ"
            count          = 388987
            categories     = (4.40, 0.29, 0.97, 0.27, 0.40, 93.67)

            choiName       = "CHOI"
            choiCount      = 36390
            choiCategories = (1.50, 0.15, 96.46, 0.03, 1.51, 0.35)

            mostCommonName = "BROWN"
            cCount         = 1380145
            cCategories    = (60.71, 34.54, 0.41, 0.83, 1.86, 1.64)

            gfd = open('grading.data', 'a')
            score = 0;
            score = score + CheckExists(name, count, categories, lines, gfd)
            score = score + CheckExists(choiName, choiCount, choiCategories, lines, gfd)
            score = score + CheckExists(mostCommonName, cCount, cCategories, lines, gfd)
            print "\n\tminmax score: ",  (score/30.0) * 100.0, "%\n"
            gfd.write("\n\tminmax score: " + str((score/30.0) * 100.0) +  "%\n")
            gfd.close()

    except OSError:
        print "-------Could not print program output--------"
        raise OSError

if __name__ == "__main__":
    try:
        CleanDestination()
        CopyFiles(sourceDir, "*.cpp", True)
        CopyFiles(sourceDir, "*.h", True)
        CopyFiles(gradingHome, "censusData1", False)

        Build()
        if CheckBuild("bs"):
            RunBS()
            FeedbackBS()
        if CheckBuild("lsearch"):
            RunLSearch()
            FeedbackLSearch()

        if CheckBuild("minmax"):
            RunMinMax()
            FeedbackMinMax()


        os.chmod(destinationDir, 0700)


        print "\n************** Successfully Submitted project[4]! ******************\n"        
    except OSError:
        printErrorMsg()
        raise

